"use strict";

// ===== Model：コアとなる機能 =====
let M = {

  // 初期設定を行う
  init: function() {
  }

  // メッセージを作成する
, buildMessage: function(name) {
    return "Hello, " + name + "!";       // 例："Hello, World!"
  }

};

// ===== View：表示に関する機能 =====
let V = {

  // 初期設定を行う
  init: function() {
  }

  // メッセージを表示する
, showMessage: function(msg) {
    $('#message').text(msg);             // メッセージ欄に表示
  }

  // アラートを表示する
, showAlert: function(msg) {
    alert(msg);                          // アラートを表示
  }

  // 名前欄とメッセージ欄をクリアする
, clear: function() {
    $('#name').val("");                  // 名前欄をクリア
    $('#message').text("");              // メッセージ欄をクリア
  }

};

// ===== Utility：ユーティリティ関数 =====
let U = {

  // 初期設定を行う
  init: function() {
  }

  // 文字列の前後の空白を取り除く
, trimString: function(str) {
    return str.trim();
    // または全角空白も削除するなら
    //return str.replace(/^[\s　]+/, '').replace(/[\s　]+$/, '');
  }

};

// ===== C：コントローラ（イベントハンドラ） =====
let C = {

  // 初期設定を行う
  init: function() {
    C.registerHandlers();    // イベントハンドラを登録
  }

  // ボタンにイベントハンドラを登録する
, registerHandlers: function() {
    $('#show-btn').on('click', C.doShowMessage); // 「表示」ボタン
    $('#clear-btn').on('click', C.doClear);      // 「クリア」ボタン
  }

  // 「表示」ボタンがクリックされたときのイベントハンドラ
, doShowMessage: function() {
    let name = $('#name').val();         // 名前欄の値を取得
    name = U.trimString(name);           // 前後の空白を除去
    if (! name) {                        // 名前が空なら
      V.showAlert("Enter your name.");   //   アラートを表示
    } else {                             // 名前が空でなければ
      let msg = M.buildMessage(name);    //   メッセージを作成
      V.showMessage(msg);                //   メッセージを表示
    }
  }

  // 「クリア」ボタンがクリックされたときのイベントハンドラ
, doClear: function() {
    V.clear();                           // 名前欄とメッセージ欄をクリア
  }

};

// 初期設定を行う
$(function() {
  U.init();    // ユーティリティの初期設定を最初に行う
  M.init();
  V.init();
  C.init();    // コントローラの初期設定を最後に行う
});
